/**
 * 
 */
package com.objectpartners.htmlunit;

import java.io.File;
import java.util.List;

import com.gargoylesoftware.htmlunit.BrowserVersion;
import com.gargoylesoftware.htmlunit.WebClient;
import com.gargoylesoftware.htmlunit.html.HtmlListItem;
import com.gargoylesoftware.htmlunit.html.HtmlPage;
import com.gargoylesoftware.htmlunit.html.HtmlUnorderedList;

/**
 * @author Jeff
 *
 */
public class ValidationTest extends AbstractHtmlUnitTest {

    private static final String HTMLUNIT_RESOURCE_DIR = "test/com/objectpartners/htmlunit/";

    /**
     * Basic file to use for tests.
     */
    private static final String TEMP_FILE = HTMLUNIT_RESOURCE_DIR + "test.html";

	private static HtmlPage htmlPage;
	private static File htmlFile = new File(TEMP_FILE);
	
	@Override
	protected void setUp() throws Exception {
		super.setUp();
        final WebClient webClient = new WebClient(BrowserVersion.FIREFOX_2);
        WebClient.setIgnoreOutsideContent(true);

        // throw an exception if we encounter any javascript errors
        webClient.setThrowExceptionOnScriptError(true);
        assertTrue(htmlFile.canRead());
        htmlPage = (HtmlPage) webClient.getPage(htmlFile.toURL());
        waitAfterPageLoad(htmlPage);		
	}
	
	public void testValidation() {
		List<HtmlListItem> testDivs = (List<HtmlListItem>) htmlPage.getByXPath("//*[contains(@class,'describe focused')]");
		assertTrue(testDivs.size() == 4);
		for (HtmlListItem htmlListItem : testDivs) {
			List<HtmlUnorderedList> test = (List<HtmlUnorderedList>) htmlListItem.getByXPath("./*[contains(@class,'its')]");
			assertTrue(test.size() == 1);
			HtmlUnorderedList result = test.get(0);
			List<HtmlListItem> passed = (List<HtmlListItem>) result.getByXPath("./*[contains(@class,'passed')]");		
			if(passed.size() == 1) {
				// succeeded
			} else {
				// TODO: get info about the test
				fail();
			}
		}
	}
}
